cal/urls.py
from django.urls import path
from . import views
from django.conf import settings
from django.conf.urls.static import static
app_name = 'cal'
urlpatterns = [
    path('', views.index, name = 'index'),
    path('wcal', views.wcal, name = 'wcal'),
]

ceo/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static
from django.conf.urls import url
from . import views

urlpatterns = [
    path('', views.index, name="redirect"),
    path('events/', include('events.urls')),
    path('polls/', include('polls.urls')),
    path('accounts/',include('accounts.urls')),
    path('administrator/',include('administrator.urls')),
    path('notification/',include('notification.urls')),
    path('nearby/',include('nearby.urls')),
    path('cal/',include('cal.urls')),
    path('notice/',include('notice.urls')),
    path('news/',include('news.urls')),
    #path('evecal/',include('eventcalendar.urls')),

    path('request/', include('request.urls')),
    # path('nearme/', include('nearme.urls')),
    path('admin/', admin.site.urls),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
admin.site.site_header = 'Administration'
admin.site.site_title = 'CEO'

events/urls.py
from django.urls import path
from . import views
app_name = 'events'
urlpatterns = [
    path('', views.index, name = 'index'),
    path('<int:event_id>/', views.detail, name = 'detail'),
    path('<int:event_id>/attend/', views.attend, name = 'attend')
]

events/models.py
from django.db.models.signals import post_save, post_delete
from django.dispatch import receiver
from django.db import models
from django.contrib.auth.models import User
# from PIL import Image
from django.conf import settings
import datetime
from django.utils import timezone
import sys, time, os
from django.core.files import File
import urllib
from apiclient.discovery import build
from httplib2 import Http
from oauth2client import file, client, tools
# Create your models here.2
class Location(models.Model):
    location_name = models.CharField('Location', max_length=20)

    def __str__(self):
        return self.location_name


class Category(models.Model):
    category_name = models.CharField('Category', max_length=30)

    def __str__(self):
        return self.category_name

    class Meta:
        verbose_name_plural = "Categories"


class Event(models.Model):
    event_source = models.CharField('Source', max_length=100)
    event_category = models.ManyToManyField(Category)
    event_title = models.CharField('Title', max_length=100)
    event_description = models.TextField('Description', blank=True, null=True)
    event_image = models.ImageField('Image', upload_to='images', blank=True, null=True, default='images/events.jpg')
    event_location = models.CharField('Location', max_length=100)
    event_start_date = models.DateField('Start Date')
    event_end_date = models.DateField('End Date', blank=True, null=True)
    event_start_time = models.TimeField('Start Time', blank=True, null=True)
    event_end_time = models.TimeField('End Time', blank=True, null=True)
    publishing_location = models.ManyToManyField(Location)
    pub_date = models.DateTimeField('Publishing Date', blank=False, default=timezone.now)
    #eid = models.CharField('Source', max_length=100, blank=True, null=True)
    def __str__(self):
        return self.event_title

    def delete(self, *args, **kwargs):
        if os.path.isfile(self.event_image.path):
            print('Yo')
            os.remove(self.event_image.path)
        print('Meow')
        super(Event, self).delete(*args, **kwargs)

class Attended(models.Model):
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    event = models.ForeignKey(Event, on_delete=models.CASCADE)

@receiver(models.signals.post_delete, sender=Event)
def auto_delete_file_on_delete(sender, instance, **kwargs):
    if instance.event_image:
        if os.path.isfile(instance.event_image.path):
            if (instance.event_image.url[14:] != "events.jpg"):
                os.remove(instance.event_image.path)
                print(str(settings.MEDIA_ROOT) + "/cropped/" + str(instance.event_image.url)[14:])
                if os.path.isfile(str(settings.MEDIA_ROOT) + "/cropped/" + str(instance.event_image.url)[14:]):
                    os.remove(str(settings.MEDIA_ROOT) + "/cropped/" + str(instance.event_image.url)[14:])

# @receiver(post_save, sender=Event, dispatch_uid="update_image")
# def update_image(sender, instance, **kwargs):
#     original = Image.open(instance.event_image)
#     w,h = original.size
#     print(w)
#     print(h)
#     if (w - h) > 0:
#         left = (w - h) // 2
#         right = (w + h) // 2
#         top = 0
#         bottom = h
#     else:
#         left = 0
#         right = w
#         top = (h - w) // 2
#         bottom = (h + w) // 2
#     cropped_image = original.crop((left, top, right, bottom))
#     print(instance.event_image.url)
#     print(instance.event_image.url[14:])
#     cropped_image.save(settings.MEDIA_ROOT + instance.event_image.url.replace("images", "cropped")[6:], cropped_image.format)
#     print(str(settings.MEDIA_ROOT) + "/cropped" + str(instance.event_image.url)[14:])

def add_to_calendar(sender, **kwargs):
    print("hello")
    e = kwargs['instance']
    try:
      try:
        start_datetime = datetime.datetime.combine(e.event_start_date,e.event_start_time)
        end_datetime = datetime.datetime.combine(e.event_end_date,e.event_end_time)
      except:
        end_time = datetime.time(23,59)
        start_time = datetime.time(0,1)
        start_datetime = datetime.datetime.combine(e.event_start_date,start_time)
        end_datetime = datetime.datetime.combine(e.event_end_date,end_time)
    except:
      end_time = datetime.time(23,59)
      start_time = datetime.time(0,1)
      start_datetime = datetime.datetime.combine(e.event_start_date,start_time)
      end_datetime = datetime.datetime.combine(e.event_start_date,end_time)
      
    SCOPES = 'https://www.googleapis.com/auth/calendar'
    store = file.Storage('credentials.json')
    creds = store.get()
    if not creds or creds.invalid:
        flow = client.flow_from_clientsecrets('client_secret.json', SCOPES)
        creds = tools.run_flow(flow, store)
    service = build('calendar', 'v3', http=creds.authorize(Http()))
    event = {
      'summary': e.event_title,
      'location': e.event_location,
      'description': e.event_description,
      'start': {
        'dateTime': start_datetime.strftime('%Y-%m-%dT%H:%M:%S.%f%z'),
        'timeZone': 'Asia/Calcutta',
      },
      'end': {
        'dateTime': end_datetime.strftime('%Y-%m-%dT%H:%M:%S.%f%z'),
        'timeZone': 'Asia/Calcutta',
      },
      'recurrence': [
      ],
      'attendees': [
      ],
      'reminders': {
        'useDefault': False,
        'overrides': [
          {'method': 'email', 'minutes': 24 * 60},
          {'method': 'popup', 'minutes': 10},
        ],
      },
    }

    event = service.events().insert(calendarId='primary', body=event).execute()
    print('Event created: %s' % (event.get('htmlLink')))

post_save.connect(add_to_calendar ,sender=Event)

# def del_from_calendar(sender, **kwargs):
#     print("hello")
#     e = kwargs['instance']
#     SCOPES = 'https://www.googleapis.com/auth/calendar'
#     store = file.Storage('credentials.json')
#     creds = store.get()
#     if not creds or creds.invalid:
#         flow = client.flow_from_clientsecrets('client_secret.json', SCOPES)
#         creds = tools.run_flow(flow, store)
#     service = build('calendar', 'v3', http=creds.authorize(Http()))
#     eid = e.eid
#     service.events().delete(calendarId='primary', eventId=eid).execute()


# post_delete.connect(add_to_calendar ,sender=Event)

events/views.py
from django.shortcuts import get_object_or_404, render
from django.http import HttpResponse
from django.utils import timezone
from .models import Event, Attended
from django.contrib.auth.decorators import login_required
from accounts.models import Ward

# Create your views here.
def index(request):
    user = request.user
    ward = Ward.objects.all().filter(user = user)[0]
    events = Event.objects.all().filter(publishing_location__in = ward.wards.all()).distinct()
    return render(request, 'events/index.html', {'events': events})
def detail(request, event_id):
    user = request.user
    ward = Ward.objects.all().filter(user = user)[0]
    events = Event.objects.all().filter(publishing_location__in = ward.wards.all()).distinct()
    event = get_object_or_404(Event, pk=event_id)
    message = "w3-green"
    return render(request, 'events/detail.html', {'event': event, 'events': events, 'messange' : message})

@login_required
def attend(request, event_id):
    events = Event.objects.all()
    event = get_object_or_404(Event, pk=event_id)
    user = request.user
    eid = event.id
    uid = user.id
    try:
        x = Attended.objects.filter(user__id=uid).filter(event__id=eid)[0]
        message = "w3-blue"
    except:
        obj = Attended()
        obj.user = request.user
        obj.event = event
        obj.save()
        message = "w3-blue"
    return render(request, 'events/detail.html', {'event': event, 'message': message, 'events': events})

templates/events/detail.html
<!DOCTYPE html>
<html>
<head>
  <title>Events</title>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://www.w3schools.com/w3css/4/w3.css">
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Poppins">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <style>
    body,h1,h2,h3,h4,h5 {font-family: "Poppins", sans-serif}
    body {font-size:16px;}
    .w3-half img{margin-bottom:-6px;margin-top:16px;opacity:0.8;cursor:pointer}
    .w3-half img:hover{opacity:1}
    @media only screen and (max-width: 400px) {
        .logoimage{
            max-width: 150px;
        }
        .logo1 {
    		display: inline;
    	}
    	.logo2 {
    		display: none;
    	}
    }
    @media only screen and (max-width: 992px) {
        .maincontent {
            padding-left: 10px;
        }
        .logo1 {
    		display: none;
    	}
    	.logo2 {
    		display: inline;
    	}
    	.header {
        display: none;
      }
        .list {
            display: none;
        }
        .maincontent {
            padding: 0px !important; 
        }
    }
    @media only screen and (max-width: 1100px) {
        .logoimage {
            width: 180px;
        }
        .maincontent {
            padding-right: 10px;
        }
        .header {
        	margin-left: -10px; margin-right: 0px; margin-bottom: 10px;
        }
    }
    @media only screen and (min-width: 1100px) {
        .w3-main {
          	margin-right: 220px;
        }
        .header {
        	margin-left: -10px; margin-right: -220px; margin-bottom: 10px;
        }
    }
  </style>
</head>
<body>

<div class="w3-container w3-top w3-green w3-xlarge" style="margin: 0px; z-index:4;"><a href="http://www.egovernments.org/"> <img style="width: 200px;" src="http://www.egovernments.org/images/egov-logo.png"></a>
	<div class="w3-right">
		<a href="javascript:void(0)" class="w3-button w3-green" onclick="w3_open_Right()" style="float: right;"><i class="fa fa-user-circle"></i></a>
	</div>
</div>
<!-- LeftSidebar/menu -->
<nav class="w3-sidebar w3-teal w3-collapse w3-large w3-padding w3-center" style="z-index:3;width:300px;font-weight:bold;" id="mySidebar"><br>
  <a href="javascript:void(0)" onclick="w3_close()" class="w3-button w3-hide-large w3-center w3-display-topmiddle"><i class="fa fa-close"></i></a>
  <hr>
  <div class="w3-bar-block">
    <a href="/events" onclick="w3_close()" class="w3-bar-item w3-button w3-hover-white">Events</a>
    <a href="/notice" onclick="w3_close()" class="w3-bar-item w3-button w3-hover-white">Notices</a> 
    <a href="/notification/index" onclick="w3_close()" class="w3-bar-item w3-button w3-hover-white weather1">Weather & Environment</a> 
    <a href="/nearby/new/parks" onclick="w3_close()" class="w3-bar-item w3-button w3-hover-white ">Places Near Me</a>
    <hr>
    <a href="#" onclick="w3_close()" class="w3-bar-item w3-button w3-hover-white">Officials and Contacts</a> 
    <a href="/cal" onclick="w3_close()" class="w3-bar-item w3-button w3-hover-white">Municipal Calendar</a> 
    <a href="#" onclick="w3_close()" class="w3-bar-item w3-button w3-hover-white">Government Facilities</a>
    <hr>
  </div>
</nav>
<!-- RightSidebar/menu -->
<nav class="w3-sidebar w3-teal w3-large w3-padding" style="z-index:3;width:200px;font-weight:bold;right: 0; display: none;" id="myRightSidebar"><br>
  <a href="javascript:void(0)" onclick="w3_close_Right()" class="w3-button w3-display-topmiddle"><i class="fa fa-close"></i></a>
  <div class="w3-bar-block">
    <div class="w3-bar">
      <div class="w3-center"><img src="avatar.png" class="w3-bar-item w3-circle"></div>
      <div class="w3-center w3-large">Mike</div>
    </div>
    <hr>
    <a href="#" onclick="w3_close_Right()" class="w3-bar-item w3-button w3-hover-white">Settings</a> 
    <a href="#" onclick="w3_close_Right()" class="w3-bar-item w3-button w3-hover-white">Notice History</a> 
    <a href="#" onclick="w3_close_Right()" class="w3-bar-item w3-button w3-hover-white">My Calendar</a>
    <a href="/polls" onclick="w3_close()" class="w3-bar-item w3-button w3-hover-white">Polls</a>
    
    <hr>
  </div>
</nav>

<!-- Top menu on small screens -->
<div class="w3-container w3-top w3-hide-large w3-teal w3-xlarge w3-center" style="z-index:5;">
  <a href="javascript:void(0)" class="w3-button w3-teal" onclick="w3_open()" style="float: left;"><i class="fa fa-bars"></i></a>
  <span class="w3-margin-top logo1"><img class="logoimage" style="padding-top: 10px" src="http://www.egovernments.org/images/egov-logo.png"></span>
  <span class="w3-margin-top logo2"><img class="logoimage" style="padding-top: 10px" src="http://www.egovernments.org/images/egov-logo.png"></span>
  <a href="javascript:void(0)" class="w3-button w3-teal" onclick="w3_open_Right()" style="float: right;"><i class="fa fa-user-circle"></i></a>
</div>

<!-- !PAGE CONTENT! -->
<div class="w3-main" onclick='w3_close_both()' style="margin-left:310px; margin-top: 51px; padding-top: 0px">
<!-------Enter Your Content Here------>
  <div class="w3-row completerow w3-blue header" style="padding-left: 10px; padding-right: 10px">
    <h4 class="w3-left" style="padding: 0px; margin-top: 10px; margin-bottom: 10px">Events</h4>
    <div class="w3-right w3-green" style="margin-top: 10px; margin-bottom: 10px; padding: 2px;">Time/Preferences</div>
  </div>
	<div class="w3-row w3-white w3-display-container maincontent" style="width: 100%;">
		<div class="w3-col m3 w3-green w3-margin-right list">
            <ul class="w3-ul">
            {% for event in events %}
              <li class="w3-padding-small"><h6 style="padding: 0px; margin: 0px"><a href="/events/{{event.id}}">{{ event.event_title}}</a></h6></li>
            {% endfor %}
            </ul>
            
		</div>
		<div class="w3-rest w3-red w3-container content" style="padding: 0px;">
            <div class="w3-gray w3-container w3-center w3-display-container" style="width: 100%; padding: 0px;">
                <img src="{{event.event_image.url}}" height="215px" class="" style="padd">
                <div class="w3-display-topright w3-container w3-margin-top">
                    <a href="javascript:history.back()"><i class="fa fa-arrow-left w3-large"></i></a>
                </div>
            </div>
            <div class="w3-red w3-container w3-padding" style="width: 100%">
                <h2 class="heading">{{ event.event_title }}</h2>
                <h6 class="source">{{ event.event_source }}</h6>
                <p class="paragraph">{{ event.event_description }} </p>
                <div class="w3-bar">
                    <div class="w3-bar-item w3-white w3-round button" style="padding: 2px; margin-bottom: 10px; margin-right: 10px">  {{ event.event_start_date | date:"D, d M" }}</div>
                    <div class="w3-bar-item w3-white w3-round button" style="padding: 2px; margin-bottom: 10px">{{ event.event_location }}</div>
                </div>     
                <form action="{% url 'events:attend' event.id %}" method="post">
{% csrf_token %}
<input type="submit" value="Attend">
</form>
		</div>
	</div>
	
<!-- 
<h1>{{ event.event_title }}</h1>
<h3>{{ event.event_source }}</h3>
<img src="{{event.event_image.url}}" width="250px">

{% if message %}
<h1>{{message}}</h1>
{% endif %}
 -->

<!------------->
</div>
<!-- Footer --
<div class="w3-green w3-container w3-bottom" id="footer" style="margin-top:75px;"><p class="w3-right">Powered by <a href="https://www.egovernments.org" title="eGovernments" target="_blank" class="w3-hover-opacity">eGovernments</a></p></div> -->
<script> 
function w3_open() {
    document.getElementById("mySidebar").style.display = "block";
    document.getElementById("myRightSidebar").style.display = "none";
}
function w3_open_Right() {
    document.getElementById("myRightSidebar").style.display = "block";
    document.getElementById("mySidebar").style.display = "none";
} 
function w3_close() {
    document.getElementById("mySidebar").style.display = "none";
}
function w3_close_Right() {
    document.getElementById("myRightSidebar").style.display = "none";
}
function w3_close_both() {
  document.getElementById("myRightSidebar").style.display = "none";
    document.getElementById("mySidebar").style.display = "none";
}
</script>

</body>
</html>